<template>
  <div>
    <el-form ref="queryForm" :model="searchForm" label-width="0" inline @submit.prevent>
      <el-form-item>
        <el-input
          v-model="searchForm.sourceName"
          placeholder="请输入名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery">搜索</el-button>
        <el-button @click="resetQuery">重置</el-button>
        <el-button type="primary" @click="openForm('create', null)">新增</el-button>
      </el-form-item>
    </el-form>
    <el-table
      v-loading="loading"
      :data="tableList"
      row-key="sourceId"
      :tree-props="{ children: 'children' }"
    >
      <el-table-column prop="sourceName" label="来源名称" />
      <el-table-column prop="sort" label="排序" width="100px" />
      <el-table-column prop="remark" label="备注" />
      <el-table-column
        label="创建时间"
        prop="createTime"
        width="180px"
        :formatter="dateFormatter"
      />
      <el-table-column label="状态">
        <template #default="{ row }">
          <dict-tag :type="DICT_TYPE.COMMON_STATUS" :value="row.status" />
        </template>
      </el-table-column>
      <el-table-column label="操作">
        <template #default="{ row }">
          <el-button type="primary" text @click="openForm('update', row)">修改</el-button>
          <el-button type="primary" text @click="openForm('createChildren', row)"> 新增 </el-button>
          <el-button type="danger" text @click="handleDelete(row.sourceId)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <DialogSource ref="sourceDialog" @success="handleQuery" />
  </div>
</template>

<script setup name="ClueSource">
import { handleTree } from '@/utils/tree'
import * as SourceApi from '@/api/clue/source'
import { dateFormatter } from '@/utils/formatTime'
import DialogSource from './DialogSource.vue'
import { DICT_TYPE } from '@/utils/dict'

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const searchForm = ref({
  sourceName: undefined
})

const sourceDialog = ref()
const tableList = ref([])
const loading = ref(false)

function handleQuery() {
  getList()
}
function resetQuery() {
  searchForm.value = {
    sourceName: ''
  }
  getList()
}

async function getList() {
  loading.value = true
  try {
    const data = await SourceApi.getSourcePage(searchForm.value)
    tableList.value = handleTree(data, 'sourceId')
  } finally {
    loading.value = false
  }
}

function openForm(type, info) {
  sourceDialog.value.open(type, info)
}

async function handleDelete(id) {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await SourceApi.deleteSource(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

onMounted(() => {
  getList()
})
</script>

<style lang="scss" scoped></style>
